# task AptLinearityCheck=/usr/users/apt/iraf/apt/AptLinearityCheck.cl
#
# Michael Ashley / 26-Sep-1998 / UNSW
#
# To do a linearity check of the CCD:
#
# - Set up a 12V bulb, and place it on the centre plug in the primary
#   mirror. Run the bulb from a regulated supply, at about 9V.
#
# - Place four thicknesses of A4 paper over the CCD window.
#
# - Lens cap on, lights out.
#
# - Adjust the signal from the CCD for a 5 sec exposure to be about
#   5000 counts (including a 2000 count bias) by changing the lamp
#   voltage.
#
# - Within IRAF:
#      cd some_directory
#      rm linlog
#      AptLinearityCheck        ! edit this file to ensure speed/gain OK
#      ./AptLin2.pl < linlog > lin
#      stsdas
#      analysis
#      fitting
#      head -20 lin > lin1      ! break the data into two section at about
#      tail -60 lin > lin2      !      15000 counts, with overlap both ways
#      gfit1d lin1 junk         ! for interactive fitting
#      tprint junk              ! to find the coefficients
#      [change $Scale in AptLin2.pl to make coeff2 = 1.000]
#      [now repeat from ./AptLin2.pl]
#      [now repeat for lin2]

procedure AptLinearityCheck ()

int junk

begin
  real bias
  real value
  int  i
  real t

  reset LastImage="undefined"
  AptWaitForNewImage

  apt "sra 1 500 550 550 speed lo gain lo"
  apt "go=clear clear expose readout"

#  for (i = 0; i < 10; i += 1) {
    for (t = 1.0; t< 75.5; t += 1.0) {
      AptLin1 t
    }

#    for (t = 45.0; t > 0.5; t -= 1.0) {
#      AptLin1 t
#    }
#  }
end
