#!/usr/local/bin/perl -w
#
# Reads the SAO J2000 catalog from the ADC CD-ROM, and converts the
# RA & DEC (J2000) into a form suitable for use in a C program.
#
# Michael Ashley / UNSW / 27-Apr-1999
#

open (CAT, "< /cdrom/astrom/saoj2000/sao.dat");

print "struct SaoCatalogStruct {
  unsigned int ra; 
  int   dec;
} SaoCatalog[] = {
";

$pi = 3.14159265359;
$ramult = 2**32/(2*$pi);
$decmult = 2**31/$pi;
$num = 0;
$first = 1;

while (<CAT>) {
    $ra  = substr ($_, 183, 10);
    $dec = substr ($_, 193, 11);
    $ra = int($ra*$ramult + 0.5);
    $dec = int($dec*$decmult + 0.5);
    if (!$first) {
	print ",$ra", "UL,$dec", "L";
    } else {
        $first = 0;
	print "$ra", "UL,$dec", "L";
    }
    $num++;
    if ($num == 3) {
	$num = 0;
	print "\n";
    }
}
print "};\n";





