#!/usr/local/bin/perl

# Usage: ./average.pl files
#
# Prints out the averages of the numbers stored in the files.
# Assumes one number per line in each file. The same number of
# numbers in each file.
#
# Michael Ashley / UNSW / 08-Apr-1998

$MaxNum   = 0;
$First    = 1;
$NumFiles = 0;

foreach $file (@ARGV) {
  $i = 0;
  $NumFiles++;
  open (IN, "<$file") || die "can't open file $file: $!";
  while (<IN>) {
    chop;
    if ($First) {
      $N[$i] = $_;
    } else {
      $N[$i] += $_;
    }
    $i++;
  }
  close IN;
  if ($First) {
    $MaxNum = $i;
    $First = 0;
  } else {
    if ($i > $MaxNum) {
      die "different number of numbers in $file"
    }
  }
}

foreach $i (@N) {
  printf "%.2f\n", $i/$NumFiles;
}

