procedure generate_matrix (images, output, xcen, ycen, boxsize, shifts)

# Michael Ashley / UNSW / 29-Apr-1998
#
# Type the following command into the IRAF cl to use this program:
#
# task generate_matrix=/usr/users/astro/mcba/apt/generate_matrix.cl

string images=""         {prompt="Images to display (can be a cube)"}
string output=""         {prompt="Output image"}
real   xcen              {prompt="X coord of first image to place in centre"}
real   ycen              {prompt="Y coord of first image to place in centre"}
int    boxsize           {prompt="Size of box extracted from each image"}
string shifts=""         {prompt="File containing offsets of images"} 

struct *imglist

begin

# Copies of the parameters.

   string Iimages, Ioutput, Ishifts
   real   Ixcen, Iycen
   int    Iboxsize

# Local variables.

   int    nimg

# Assign positional parameters to local variables.

   Iimages       = images
   Ioutput       = output
   Ishifts       = shifts
   Ixcen         = Ixcen
   Iycen         = Iycen
   Iboxsize      = boxsize

# Restore defaults for all the IRAF routines we use.

   unlearn sections

   first = yes

# Form temporary filenames.

   imgfile     =  mktemp ("/tmp/mcba")

# Check existence of input @file.

   if ( (stridx("@",Iimages) == 1) &&
        (!access( substr(Iimages,2,strlen(Iimages))) ) ) {
      print ("GENERATE_MATRIX: Input image @file ",Iimages," does not exist",
         " - processing aborted.")
      beep ; goto cleanup
   }

# Expand input template into file lists.

   sections (Iimages, option="fullname", > imgfile)
   nimg = sections.nimages
   if (nimg == 0) {
      print ("FIND_VAR: No images in input list - processing aborted.")
      beep ; goto cleanup
   }


# Check existence of shifts file.

   if (!access(Ishifts)) {
      print ("GENERATE_MATRIX: Can't access shifts file.")
      beep ; goto cleanup
   }
        
   nx = int(sqrt(nimg))
   ny = int((nrows - 0.5) / nx) + 1
   printf ("%d images, = %d x $d\n", nimg, nx, ny)

   xpix = nx * boxsize
   ypix = ny * boxsize
      
   imexpr (expr="repl(0,"//xpix//")", output=Ioutput, dims=xpix//","//ypix)

goto cleanup

# Scan through input images.

   while (fscan (IMGLIST,img) != EOF) {
      if ( !access (img) && !access (img//".fits") && !access (img//".imh") ) {
         print ("GENERATE_MATRIX: Image ",img," does not exist")
         beep ; goto cleanup
      } else {
         if (stridx('.',img) != 0) {
            img = substr(img,1,stridx('.',img)-1)
         }

   	 if (first) {
     }}}

cleanup:

# Delete temporary files
    SHIFTS = ""

#   delete (imgfile, ver-, >& "dev$null")



end
