
#
# SIGMA_IMAGE -- Calculates magnitudes of standard stars and of particular 
#                  variables to produce light curves.
#
# e.g., sigma_image (@images, ver+)
#
# History: 21-APR-98  JMR and MCBA 
# 
# task sigma_image=scripts$sigma_image.cl

#procedure sigma_image (images)
procedure sigma_image 


#string images           {prompt="List of input images"}

bool   verbose          {no,  prompt="Verbose output?"}


#struct *imglist


begin

# Copies of the parameters.
  
#   string Iimages, imgfile
   string junk
#   int nimg
#   struct img
   bool   first
   
# Assign positional parameters to local variables.

#   Iimages  = images


# Make temorary files

	junk = mktemp ("/tmp/junk")
#  	imgfile = mktemp ("/tmp/imgfile")

# Restore defaults for all the IRAF routines we use.

   unlearn sections
   unlearn imarith
   unlearn imstat
   unlearn imexpr
  
#   first = yes


# Check existence of input @file.

#   if ( (stridx("@",Iimages) == 1) &&
##        (! access( substr(Iimages,2,strlen(Iimages))) ) ) {
#      print ("SIGMA_IMAGE: Input image @file ",Iimages," does not exist",
#         " - processing aborted.")
#      beep ; goto cleanup
#   }


# Expand input template into file lists.

#   sections (Iimages, option="fullname", > imgfile)
#   nimg = sections.nimages
#   if (nimg == 0) {
#     print ("SIGMA_IMAGE: No images in input list - processing aborted.")
#      beep ; goto cleanup
#   }


# 	imglist = imgfile


# Scan through input images, cheking existence of files.

#   while (fscan(imglist,img) != EOF) {
#      if ( !access(img) && !access(img//".fits") ) {
#        print ("SIGMA_IMAGE: Image ",img," does not exist")
#         beep ; goto cleanup
#      } else {
#         if (stridx('.',img) != 0) {
#            img = substr(img,1,stridx('.',img)-1)
#         }
   		
#         printf ("\nProcessing %s ...", img)
         

# Defining images for imexpr..

	imexpr.a = "im25994s"
	imexpr.b = "im25995s" 
	imexpr.c = "im26006s"
	imexpr.d = "im26007s"
	imexpr.e = "im26023s"
	imexpr.f = "im26024s"
	imexpr.g = "im26035s"
	imexpr.h = "im26036s" 
 
        imdelete ("j*", ver-, >& "dev$null")

# Calculating the min and max of all the images.

	imexpr (expr="min(a,b,c,d,e,f,g,h)", output="j1", verbose-) 

	imexpr (expr="max(a,b,c,d,e,f,g,h)",output="j2", verbose-)
 

# Calculating the difference between the max and min,to get the range of values

	imarith (operand1="j2",op= "-",operand2= "j1", result="j3")


# Create a mask to find the standard stars.

	imexpr.y = "j3"

	imexpr (expr="(y < 0.12 && y > 0.01) ? 1 : 0", output="j4")


# Create files containing the standard stars.

	imdelete ("z*", ver-, >& "dev$null")

	imarith (operand1="j4", op="*", operand2=imexpr.a, result="z1")	
	imarith (operand1="j4", op="*", operand2=imexpr.b, result="z2")
	imarith (operand1="j4", op="*", operand2=imexpr.c, result="z3")
	imarith (operand1="j4", op="*", operand2=imexpr.d, result="z4")
	imarith (operand1="j4", op="*", operand2=imexpr.e, result="z5")
	imarith (operand1="j4", op="*", operand2=imexpr.f, result="z6")
	imarith (operand1="j4", op="*", operand2=imexpr.g, result="z7")
	imarith (operand1="j4", op="*", operand2=imexpr.h, result="z8")

    #delete ("s2", ver-, >& "dev$null")

     imstatistics (images="z1", fields="mean")
  
     s2 = fields.mean
     printf ("mean = (%2.4f);", s2)

#	}
#}

cleanup:

#   imglist=""
#   delete (imgfile, ver-, >& "dev$null")
   delete (junk, ver-, >& "dev$null")

end





