#!/usr/local/bin/perl

open (ORIGINAL, "< $ARGV[0]") || die "can't open $ARGV[0]: $!";
open (REVISED,  "< $ARGV[1]") || die "can't open $ARGV[1]: $!";
open (NEW,      "> $ARGV[2]") || die "can't open $ARGV[2]: $!";

$warnings    = 0;
$large_error = 0;

    while (<REVISED>) {
        if (/^#Shifts/) {
            last;
	}
        if (/^Warning/) {
	    $warnings++;
	}
        if (/ (\(.+\))\s+\S+(\(.+\))\s+/) {
            if ($1 > 0.2 || $2 > 0.2) {
              $large_error++;
             }
        } 
    }

printf "A total of $warnings warnings were issued by imcentroid\n";
printf "$large_error positions had shifts more than 0.2 pixels\n\n";

    printf "   Original shift       New shift          Delta     Nstars  Image\n";

    while (<ORIGINAL>) {
	if (/^\s*(\S+)\s+(\S+)/) {
	    $oldx = $1;
	    $oldy = $2;
	    $_ = <REVISED>;
	    if (/^\s*(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)/) {
		$image  = $1;
		$newx   = $2;
		$newy   = $4;
                $nstars = $6;
	    } else {
	        die "format error in $ARGV[1]";
    	    }
	    printf "(%7.2f,%7.2f) (%7.2f,%7.2f) (%7.2f,%7.2f) %5d %s\n",
              $oldx, $oldy, $newx, $newy, 
              $newx - $oldx, $newy - $oldy, $nstars, $image;
            printf NEW "%7.2f %7.2f %s\n", $newx, $newy, $image;
	} else {
	    die "format error in $ARGV[0]";
	}
    }
close (ORIGINAL);
close (REVISED);
close (NEW);
